/********************************************************************************
 * ePIMSs $Source: Connection.groovy $
 * ePIMSs $Project: com.epimss.services $
 *
 * Copyright (c) 2006 - 2011 by ePIMSs						 
 *
 * All rights reserved. This program and the accompanying materials must NOT be
 * copied, used, transferred in any form without the expressed written 
 * permission of the author.	
 *	
 * Removing this notice and using the application does NOT negate the legal 
 * copyright notice.	
 *
 * @initialAPIImplementationBy St Clair Clarke
 *  
 * @author $Author: st.clair.clarke $
 *
 * @source $Source: Connection.groovy $
 * @path $FPath: src-java/com/epimss/services/osgi/ds/impl $
 * @project $Project: com.epimss.services $
 * @generics $Generic: mainline $
 *
 * @lastChangedBy	 $Author: st.clair.clarke $
 * @lastChangedDate $Date: 2011/05/02 15:28:10 $
 *
 * @version $Revision: 1.0 $ $Date: 2011/05/02 15:28:10 $
 *
 * @changeRequest $CR: com.epimss.services000002 $
 * @state $State: Develop/Test $
 ********************************************************************************/



package _com.epimss.lab.db;



import javax.jdo.PersistenceManager
import javax.jdo.PersistenceManagerFactory





/**
 * The domain|UI model for the {@link} UI. TODO!
 *
 * @created  April 27, 2009 12:51:22 PM by St Clair Clarke
 * @since    1.0
 * @version  $Revision: 1.0 $ $Date: 2011/05/02 15:28:10 $
 */
class Connection
{
    //~ Methods ----------------------------------------------------------------
    
    private PersistenceManager pm
    
    private String userid
    private String password
    private String datastore
    
    
    
    /**
     * The <code>connect()</code> method TODO!
     *
     * @created  April 27, 2009 12:51:22 PM by St Clair Clarke
     *
     * @param    datastore    String TODO!
     * @param    userid    String TODO!
     * @param    password  String TODO!
     *
     * @since    1.0
     */
    
    Connection(String datastore, String userid, String password )
    {
        this.userid = userid
        this.password = password
        this.datastore = datastore
        
    }   // end method connect
    
    
    
    /**
     * The <code>connect()</code> method TODO!
     *
     * @created  April 27, 2009 12:51:22 PM by St Clair Clarke
     *
     * @param    datastore    String TODO!
     * @param    userid    String TODO!
     * @param    password  String TODO!
     *
     * @return   <code>PersistenceManager</code> type if suscessfully executes.
     *
     * @see      com.epimss.services.osgi.ds.service.ConnectionService#connect(java.lang.String, java.lang.String)
     * @since    1.0
     */
    @Override
    PersistenceManager connect()
    {
        
        switch( datastore )
        {
            case { datastore == 'db4o'}:
                DataStore.instance.db4oPMF().getPersistenceManager( userid, password)
                break
            
            case { datastore == 'neodatis'}:
                DataStore.instance.neodatisPMF().getPersistenceManager( userid, password)
                break
            
            
            case { datastore == 'objectdb'}:
                DataStore.instance.objectDbPMF().getPersistenceManager( userid, password)
                break
            
            default: null
        }
        
    }   // end method connect
    
    
    
    
    
    
    /**
     * The <code>deleteAll()</code> method TODO!
     *
     * @created  April 27, 2009 12:51:22 PM by St Clair Clarke
     *
     * @param    collection  Collection TODO!
     *
     * @see      com.epimss.services.osgi.ds.service.ConnectionService#deleteAll(java.util.Collection)
     * @since    1.0
     */
    @Override
    void deleteAll( Collection collection )
    {
        // TODO Auto-generated method stub
        
    }   // end method deleteAll
    
    
    
    /**
     * The <code>disconnect()</code> method TODO!
     *
     * @created  April 27, 2009 12:51:22 PM by St Clair Clarke
     * @see      com.epimss.services.osgi.ds.service.ConnectionService#disconnect()
     * @since    1.0
     */
    @Override
    void disconnect()
    {
        // TODO Auto-generated method stub
        
    }   // end method disconnect
    
    
    
    /**
     * The <code>find()</code> method TODO!
     *
     * @created  April 27, 2009 12:51:22 PM by St Clair Clarke
     *
     * @return   <code>Collection</code> type if suscessfully executes.
     *
     * @see      com.epimss.services.osgi.ds.service.ConnectionService#find()
     * @since    1.0
     */
    @Override
    Collection find()
    {
        // TODO Auto-generated method stub
        return( null );
        
    }   // end method find
    
    
    
    /**
     * The <code>store()</code> method TODO!
     *
     * @created  April 27, 2009 12:51:22 PM by St Clair Clarke
     *
     * @param    instance  Object TODO!
     *
     * @see      com.epimss.services.osgi.ds.service.ConnectionService#store(java.lang.Object)
     * @since    1.0
     */
    @Override
    void store( Object instance )
    {
        PersistenceManager pm = connect()
        
        def transaction = pm.currentTransaction()
        
        try
        {
            transaction.begin()
            pm.makePersistent( instance )
            transaction.commit()
        }
        catch( e )
        {
            print "com.epimss.lab.db.Connection.store(instance) "
            e.printStackTrace()
            
            
            //            SiAuto.main.logException( "com.epimss.lab.db.Connection.store(instance)", e )
        }
        finally
        {
            
            if( transaction.isActive() )
                transaction.rollback()
            
            if( !pm.isClosed() )
                pm.close()
            
            if( !pm.persistenceManagerFactory.isClosed() )
            {
                pm.persistenceManagerFactory.close()
            }
        }
        
    }   // end method store
    
    
    
}   // end class Connection
