/********************************************************************************
 * ePIMSs $Source: RequestDateAndNumberForm.java $
 * ePIMSs $Project: com.epimss.lab $
 *
 * Copyright (c) 2006 - 2011 by ePIMSs						 
 *
 * All rights reserved. This program and the accompanying materials must NOT be
 * copied, used, transferred in any form without the expressed written 
 * permission of the author.	
 *	
 * Removing this notice and using the application does NOT negate the legal 
 * copyright notice.	
 *
 * @initialAPIImplementationBy St Clair Clarke
 *  
 * @author $Author: st.clair.clarke $
 *
 * @source $Source: RequestDateAndNumberForm.java $
 * @path $FPath: src-java/com/epimss/lab/ui $

 * @project $Project: com.epimss.lab $
 * @generics $Generics$
 *
 * @lastChangedBy	 $Author: st.clair.clarke $
 * @lastChangedDate $Date: 2011/04/16 15:48:07 $
 *
 * @version $Revision: 1.9 $ $Date: 2011/04/16 15:48:07 $
 *
 * @changeRequest $CR: com.epimss.lab|000020 $
 * @state $State: Develop/Test $
 ********************************************************************************/


package _com.epimss.lab.ui.misc;


import com.richclientgui.toolbox.propagate.PropagateComposite;

import org.eclipse.swt.SWT;

import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.custom.ViewForm;

import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;

import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;

import org.eclipse.ui.forms.widgets.FormToolkit;

import org.eclipse.wb.swt.SWTResourceManager;

/**
 * The domain|UI model for the {@link} UI. TODO!
 *
 * @created  January 4, 2011 4:16:28 PM by St Clair Clarke
 * @since    1.0
 * @version  $Revision: 1.9 $ $Date: 2011/04
 */
public class RequestDateAndNumberViewForm extends Composite
{
    //~ Instance fields --------------------------------------------------------

    private final FormToolkit        toolkit                        = new FormToolkit( Display.getCurrent() );
    private CLabel                   requestNumberDatesAndTimesCLbl;

    private PropagateComposite       rootPrpgteCmpst;
    private PropagateComposite       viewFormHostPrpgteCmpst;

    private RequestDateAndNumberForm requestDateAndNumberForm;

    private ViewForm                 viewForm;

    //~ public -----------------------------------------------------------------

    /**
     * Creates a new <code>RequestDateAndNumberForm</code> object.
     *
     * @created  January 4, 2011 4:16:28 PM by St Clair Clarke
     *
     * @param    parent  <code>Composite</code> TODO!
     * @param    style   <code>int</code> TODO!
     *
     * @since    1.0
     */
    public RequestDateAndNumberViewForm( Composite parent, int style )
    {
        super( parent, style );

        try
        {
            createContents();

        }
        catch( Exception e )
        {
            System.err.println( "com.epimss.lab.ui.misc.RequestDateAndNumberForm.RequestDateAndNumberForm(parent, style), " + e );

        }   // end try-catch

    }   // end ctor RequestDateAndNumberViewForm

    //~ Methods ----------------------------------------------------------------

    /**
     * The <code>createContents()</code> method TODO!
     *
     * @created  April 16, 2011 3:09:11 PM by St Clair Clarke
     * @since    1.0
     */
    private void createContents()
    {
        addDisposeListener( new DisposeListener()
            {
                @Override
                public void widgetDisposed( DisposeEvent e )
                {
                    toolkit.dispose();

                }   // end method widgetDisposed

            } );
        toolkit.adapt( this );
        toolkit.paintBordersFor( this );
        setLayout( new FillLayout( SWT.HORIZONTAL ) );

        {
            rootPrpgteCmpst = new PropagateComposite( this, SWT.NONE );
            rootPrpgteCmpst.setData( "name", "rootPrpgteCmpst" );
            toolkit.adapt( rootPrpgteCmpst );
            toolkit.paintBordersFor( rootPrpgteCmpst );
            rootPrpgteCmpst.setLayout( new GridLayout( 5, false ) );

            {
                viewForm = new ViewForm( rootPrpgteCmpst, SWT.BORDER );
                viewForm.setLayoutData( new GridData( SWT.FILL, SWT.CENTER, true, false, 5, 1 ) );
                viewForm.setData( "name", "viewForm" );
                toolkit.adapt( viewForm );
                toolkit.paintBordersFor( viewForm );

                {
                    requestNumberDatesAndTimesCLbl = new CLabel( viewForm, SWT.NONE );
                    requestNumberDatesAndTimesCLbl.setFont( SWTResourceManager.getFont( "Segoe UI", 9, SWT.BOLD ) );
                    requestNumberDatesAndTimesCLbl.setData( "name", "requestNumberDatesAndTimesCLbl" );
                    toolkit.adapt( requestNumberDatesAndTimesCLbl );
                    toolkit.paintBordersFor( requestNumberDatesAndTimesCLbl );
                    viewForm.setTopLeft( requestNumberDatesAndTimesCLbl );
                    requestNumberDatesAndTimesCLbl.setText( "Request Number, Dates and Times" );

                }

                {
                    viewFormHostPrpgteCmpst = new PropagateComposite( viewForm, SWT.NONE );
                    viewFormHostPrpgteCmpst.setData( "name", "viewFormHostPrpgteCmpst" );
                    toolkit.adapt( viewFormHostPrpgteCmpst );
                    toolkit.paintBordersFor( viewFormHostPrpgteCmpst );
                    viewForm.setContent( viewFormHostPrpgteCmpst );
                    viewFormHostPrpgteCmpst.setLayout( new GridLayout( 1, false ) );

                    {
                        requestDateAndNumberForm = new RequestDateAndNumberForm( viewFormHostPrpgteCmpst, SWT.NONE );
                        requestDateAndNumberForm.setLayoutData( new GridData( SWT.FILL, SWT.CENTER, true, false, 1, 1 ) );
                        requestDateAndNumberForm.setData( "name", "requestDateAndNumberForm" );
                        toolkit.adapt( requestDateAndNumberForm );
                        toolkit.paintBordersFor( requestDateAndNumberForm );

                    }

                }

            }

        }

    }   // end method createContents


    /**
     * Retrieves the <code>requestDateAndNumberForm</code> property from this bean.
     *
     * @created  May 21, 2011 8:18:59 PM by St Clair Clarke
     *
     * @return   <code>RequestDateAndNumberForm</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    public RequestDateAndNumberForm getRequestDateAndNumberForm()
    {
        return( requestDateAndNumberForm );

    }   // end method getRequestDateAndNumberForm

}   // end class RequestDateAndNumberViewForm
