/********************************************************************************
 * ePIMSs $Source$
 * ePIMSs $Project$
 *
 * Copyright (c) 2006 - 2011 by ePIMSs						 
 *
 * All rights reserved. This program and the accompanying materials must NOT be
 * copied, used, transferred in any form without the expressed written 
 * permission of the author.	
 *	
 * Removing this notice and using the application does NOT negate the legal 
 * copyright notice.	
 *
 * @initialAPIImplementationBy St Clair Clarke
 *  
 * @author $Author$
 *
 * @source $Source$
 * @path $FPath$

 * @project $Project$
 * @generics $Generics$
 *
 * @lastChangedBy	 $Author$
 * @lastChangedDate $Date$
 *
 * @version $Revision$ $Date$
 *
 * @changeRequest $CR$
 * @state $State$
 ********************************************************************************/


package _com.epimss.lab.ui.toxicology;


import _com.epimss.lab.data.misc.OtherRqst;
import _com.epimss.lab.data.misc.RequestDateAndNumber;

import _com.epimss.lab.data.toxicology.TherapeauticDrugScreenRqst;

import _com.epimss.lab.db.Connection;

import org.eclipse.jface.wizard.Wizard;

/**
 * The domain|UI model for the {@link} UI. TODO!
 *
 * @created  June 30, 2011 3:44:41 PM by St Clair Clarke
 * @since    1.0
 * @version  $Revision$ $Date$
 */
public class TherapeauticDrugScreenRqstWizard extends Wizard
{
    //~ Instance fields --------------------------------------------------------

    private TherapeauticDrugScreenRqst           therapeauticDrugScreenRqst;
    private TherapeauticDrugScreenRqstWizardPage therapeauticDrugScreenRqstWizardPage;

    //~ public -----------------------------------------------------------------

    /**
     * Creates a new <code>TherapeauticDrugScreenRqstWizard</code> object.
     *
     * @created  June 30, 2011 3:44:41 PM by St Clair Clarke
     * @since    1.0
     */
    public TherapeauticDrugScreenRqstWizard()
    {
        setWindowTitle( TherapeauticDrugScreenRqstWizardPage.TITLE );
        setNeedsProgressMonitor( true );

    }   // end ctor TherapeauticDrugScreenRqstWizard

    //~ Methods ----------------------------------------------------------------

    /**
     * The <code>addPages()</code> method TODO!
     *
     * @see    org.eclipse.jface.wizard.Wizard#addPages()
     * @since  1.0
     */
    @Override
    public void addPages()
    {
        therapeauticDrugScreenRqstWizardPage = new TherapeauticDrugScreenRqstWizardPage();

        addPage( therapeauticDrugScreenRqstWizardPage );

    }   // end method addPages


    /**
     * The <code>canFinish()</code> method TODO!
     *
     * @return  <code>boolean</code> type if suscessfully executes.
     *
     * @see     org.eclipse.jface.wizard.Wizard#canFinish()
     * @since   1.0
     */
    @Override
    public boolean canFinish()
    {
        return( therapeauticDrugScreenRqstWizardPage.isPageComplete() );

    }   // end method canFinish


    /**
     * The <code>performCancel()</code> method TODO!
     *
     * @return  <code>boolean</code> type if suscessfully executes.
     *
     * @see     org.eclipse.jface.wizard.Wizard#performCancel()
     * @since   1.0
     */
    @Override
    public boolean performCancel()
    {
        try
        {
            therapeauticDrugScreenRqstWizardPage.setTherapeauticDrugScreenRqst( new TherapeauticDrugScreenRqst() );
            therapeauticDrugScreenRqstWizardPage.getM_bindingContext()
                                                .updateTargets();

        }
        catch( Exception e )
        {
            System.err.println( "com.epimss.lab.ui.toxicology.TherapeauticDrugScreenRqstWizard.performCancel()," + e );

        }   // end try-catch

        return( true );

    }   // end method performCancel


    /**
     * The <code>performFinish()</code> method TODO!
     *
     * @return  <code>boolean</code> type if suscessfully executes.
     *
     * @see     org.eclipse.jface.wizard.Wizard#performFinish()
     * @since   1.0
     */
    @Override
    public boolean performFinish()
    {
        try
        {
            therapeauticDrugScreenRqstWizardPage.getM_bindingContext()
                                                .updateModels();

            therapeauticDrugScreenRqst = therapeauticDrugScreenRqstWizardPage.getTherapeauticDrugScreenRqst();

            RequestDateAndNumber requestDateAndNumber = therapeauticDrugScreenRqstWizardPage.getTherapeauticDrugScreenRqstViewForm()
                                                                                            .getRequestDateAndNumberViewForm()
                                                                                            .getRequestDateAndNumberForm()
                                                                                            .getRequestDateAndNumber();

            therapeauticDrugScreenRqst.setRequestDateAndNumber( requestDateAndNumber );


            OtherRqst otherRqst = therapeauticDrugScreenRqst.getOtherRqst();
            otherRqst.setRequestDateAndNumber( therapeauticDrugScreenRqst.getRequestDateAndNumber() );

            new Connection( "objectdb", "admin", "admin" ).store( therapeauticDrugScreenRqst );

        }
        catch( Exception e )
        {
            System.err.println( "com.epimss.lab.ui.toxicology.TherapeauticDrugScreenRqstWizard.performFinish(), " + e );

        }   // end try-catch

        return( true );

    }   // end method performFinish

}   // end class TherapeauticDrugScreenRqstWizard
