/********************************************************************************
 * ePIMSs $Source$
 * ePIMSs $Project$
 *
 * Copyright (c) 2006 - 2011 by ePIMSs						 
 *
 * All rights reserved. This program and the accompanying materials must NOT be
 * copied, used, transferred in any form without the expressed written 
 * permission of the author.	
 *	
 * Removing this notice and using the application does NOT negate the legal 
 * copyright notice.	
 *
 * @initialAPIImplementationBy St Clair Clarke
 *  
 * @author $Author$
 *
 * @source $Source$
 * @path $FPath$

 * @project $Project$
 * @generics $Generics$
 *
 * @lastChangedBy	 $Author$
 * @lastChangedDate $Date$
 *
 * @version $Revision$ $Date$
 *
 * @changeRequest $CR$
 * @state $State$
 ********************************************************************************/


package _com.epimss.lab.ui.toxicology;


import _com.epimss.lab.converters.BigIntegerToStringConverter;
import _com.epimss.lab.converters.StringToBigIntegerConverter;

import _com.epimss.lab.data.toxicology.TherapeauticDrugScreenRqst;

import org.eclipse.core.databinding.DataBindingContext;
import org.eclipse.core.databinding.UpdateValueStrategy;

import org.eclipse.core.databinding.beans.BeansObservables;

import org.eclipse.core.databinding.observable.value.IObservableValue;

import org.eclipse.jface.databinding.swt.SWTObservables;

import org.eclipse.jface.wizard.WizardPage;

import org.eclipse.swt.SWT;

import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;

import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;

import org.eclipse.ui.forms.widgets.FormToolkit;


/**
 * The domain|UI model for the {@link} UI. TODO!
 *
 * @created  June 21, 2011 4:32:28 PM by St Clair Clarke
 * @since    1.0
 * @version  $Revision$ $Date$
 */
public class TherapeauticDrugScreenRqstWizardPage extends WizardPage
{
    //~ Static fields/initializers ---------------------------------------------

    /** 
     */
    public static final String PAGE_NAME = "com.epimss.lab.ui.toxicology.TherapeauticDrugScreenRqstWizardPage";

    /** 
     */
    public static final String TITLE = "Therapeautic Drugs Screen Requests";

    //~ Instance fields --------------------------------------------------------

    private final FormToolkit                  formToolkit                        = new FormToolkit( Display.getDefault() );
    private Composite                          rootFormCmpst;

    private DataBindingContext                 m_bindingContext;

    private TherapeauticDrugScreenRqst         therapeauticDrugScreenRqst         = new TherapeauticDrugScreenRqst();

    private TherapeauticDrugScreenRqstViewForm therapeauticDrugScreenRqstViewForm;

    //~ public -----------------------------------------------------------------

    /**
     * Create the wizard.
     *
     * @since  1.0
     */
    public TherapeauticDrugScreenRqstWizardPage()
    {
        super( PAGE_NAME );
        setPageComplete( false );
        setTitle( TITLE );
        setDescription( "Use this page to request therapeautic drugs screens" );

    }   // end ctor TherapeauticDrugScreenRqstWizardPage

    //~ Methods ----------------------------------------------------------------

    /**
     * Create contents of the wizard.
     *
     * @param  parent  $param.type$ TODO!
     *
     * @since  1.0
     */
    @Override
    public void createControl( Composite parent )
    {
        Composite container = new Composite( parent, SWT.NULL );
        setControl( container );
        container.setLayout( new FillLayout( SWT.HORIZONTAL ) );

        {
            rootFormCmpst = formToolkit.createComposite( container, SWT.NONE );
            rootFormCmpst.setData( "name", "rootFormCmpst" );
            formToolkit.paintBordersFor( rootFormCmpst );
            rootFormCmpst.setLayout( new GridLayout( 1, false ) );

            {
                therapeauticDrugScreenRqstViewForm = new TherapeauticDrugScreenRqstViewForm( rootFormCmpst, SWT.NONE );
                therapeauticDrugScreenRqstViewForm.getTherapeauticDrugScreenRqstForm()
                                                  .getOtherRqstForm()
                                                  .getRequestTxt()
                                                  .addModifyListener( new ModifyListener()
                        {
                            @Override
                            public void modifyText( ModifyEvent e )
                            {
                                setPageComplete( isPageValid() );

                            }   // end method modifyText

                        } );
                therapeauticDrugScreenRqstViewForm.getTherapeauticDrugScreenRqstForm()
                                                  .getAntipsychoticsCBtn()
                                                  .addSelectionListener( new SelectionAdapter()
                        {
                            @Override
                            public void widgetSelected( SelectionEvent e )
                            {
                                setPageComplete( isPageValid() );

                            }   // end method widgetSelected

                        } );
                therapeauticDrugScreenRqstViewForm.getTherapeauticDrugScreenRqstForm()
                                                  .getHepatotoxinsCBtn()
                                                  .addSelectionListener( new SelectionAdapter()
                        {
                            @Override
                            public void widgetSelected( SelectionEvent e )
                            {
                                setPageComplete( isPageValid() );

                            }   // end method widgetSelected

                        } );
                therapeauticDrugScreenRqstViewForm.getTherapeauticDrugScreenRqstForm()
                                                  .getTegretolCBtn()
                                                  .addSelectionListener( new SelectionAdapter()
                        {
                            @Override
                            public void widgetSelected( SelectionEvent e )
                            {
                                setPageComplete( isPageValid() );

                            }   // end method widgetSelected

                        } );
                therapeauticDrugScreenRqstViewForm.getTherapeauticDrugScreenRqstForm()
                                                  .getPhenobarbCBtn()
                                                  .addSelectionListener( new SelectionAdapter()
                        {
                            @Override
                            public void widgetSelected( SelectionEvent e )
                            {
                                setPageComplete( isPageValid() );

                            }   // end method widgetSelected

                        } );
                therapeauticDrugScreenRqstViewForm.getTherapeauticDrugScreenRqstForm()
                                                  .getDilantinCBtn()
                                                  .addSelectionListener( new SelectionAdapter()
                        {
                            @Override
                            public void widgetSelected( SelectionEvent e )
                            {
                                setPageComplete( isPageValid() );

                            }   // end method widgetSelected

                        } );
                therapeauticDrugScreenRqstViewForm.getTherapeauticDrugScreenRqstForm()
                                                  .getAntiepilepticsCBtn()
                                                  .addSelectionListener( new SelectionAdapter()
                        {
                            @Override
                            public void widgetSelected( SelectionEvent e )
                            {
                                setPageComplete( isPageValid() );

                            }   // end method widgetSelected

                        } );
                therapeauticDrugScreenRqstViewForm.getTherapeauticDrugScreenRqstForm()
                                                  .getDigoxinCBtn()
                                                  .addSelectionListener( new SelectionAdapter()
                        {
                            @Override
                            public void widgetSelected( SelectionEvent e )
                            {
                                setPageComplete( isPageValid() );

                            }   // end method widgetSelected

                        } );
                therapeauticDrugScreenRqstViewForm.getTherapeauticDrugScreenRqstForm()
                                                  .getAspirinCBtn()
                                                  .addSelectionListener( new SelectionAdapter()
                        {
                            @Override
                            public void widgetSelected( SelectionEvent e )
                            {
                                setPageComplete( isPageValid() );

                            }   // end method widgetSelected

                        } );
                therapeauticDrugScreenRqstViewForm.getTherapeauticDrugScreenRqstForm()
                                                  .getLithiumCBtn()
                                                  .addSelectionListener( new SelectionAdapter()
                        {
                            @Override
                            public void widgetSelected( SelectionEvent e )
                            {
                                setPageComplete( isPageValid() );

                            }   // end method widgetSelected

                        } );
                therapeauticDrugScreenRqstViewForm.getTherapeauticDrugScreenRqstForm()
                                                  .getCardiotoxinsCBtn()
                                                  .addSelectionListener( new SelectionAdapter()
                        {
                            @Override
                            public void widgetSelected( SelectionEvent e )
                            {
                                setPageComplete( isPageValid() );

                            }   // end method widgetSelected

                        } );
                therapeauticDrugScreenRqstViewForm.getTherapeauticDrugScreenRqstForm()
                                                  .getOtherCBtn()
                                                  .addSelectionListener( new SelectionAdapter()
                        {
                            @Override
                            public void widgetSelected( SelectionEvent e )
                            {
                                setPageComplete( isPageValid() );

                            }   // end method widgetSelected

                        } );
                therapeauticDrugScreenRqstViewForm.setLayoutData( new GridData( SWT.FILL, SWT.CENTER, true, false, 1, 1 ) );
                therapeauticDrugScreenRqstViewForm.setData( "name", "therapeauticDrugScreenRqstViewForm" );
                formToolkit.adapt( therapeauticDrugScreenRqstViewForm );
                formToolkit.paintBordersFor( therapeauticDrugScreenRqstViewForm );
                therapeauticDrugScreenRqstViewForm.setLayout( new GridLayout( 1, false ) );

            }

        }

        m_bindingContext = initDataBindings();

    }   // end method createControl


    /**
     * The <code>initDataBindings()</code> method TODO!
     *
     * @created  June 21, 2011 5:36:32 PM by St Clair Clarke
     *
     * @return   <code>DataBindingContext</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    protected DataBindingContext initDataBindings()
    {
        DataBindingContext bindingContext = new DataBindingContext();

        //
        try
        {
            IObservableValue    therapeauticDrugScreenRqstViewFormgetRequestDateAndNumberViewFormgetRequestDateAndNumberFormgetMrnTxtObserveTextObserveWidget = SWTObservables.observeText( therapeauticDrugScreenRqstViewForm
                                                                                                                                                                                                    .getRequestDateAndNumberViewForm()
                                                                                                                                                                                                    .getRequestDateAndNumberForm()
                                                                                                                                                                                                    .getMrnTxt(),
                                                                                                                                                                                            SWT.Modify );
            IObservableValue    therapeauticDrugScreenRqstRequestDateAndNumbermrnObserveValue                                                                 = BeansObservables.observeValue( therapeauticDrugScreenRqst,
                                                                                                                                                                                               "requestDateAndNumber.mrn" );
            UpdateValueStrategy strategy                                                                                                                      = new UpdateValueStrategy();
            strategy.setConverter( new StringToBigIntegerConverter() );

            UpdateValueStrategy strategy_1 = new UpdateValueStrategy();
            strategy_1.setConverter( new BigIntegerToStringConverter() );
            bindingContext.bindValue( therapeauticDrugScreenRqstViewFormgetRequestDateAndNumberViewFormgetRequestDateAndNumberFormgetMrnTxtObserveTextObserveWidget,
                                      therapeauticDrugScreenRqstRequestDateAndNumbermrnObserveValue, strategy, strategy_1 );

            //
            IObservableValue    therapeauticDrugScreenRqstViewFormgetRequestDateAndNumberViewFormgetRequestDateAndNumberFormgetNumberTxtObserveTextObserveWidget = SWTObservables.observeText( therapeauticDrugScreenRqstViewForm
                                                                                                                                                                                                       .getRequestDateAndNumberViewForm()
                                                                                                                                                                                                       .getRequestDateAndNumberForm()
                                                                                                                                                                                                       .getNumberTxt(),
                                                                                                                                                                                               SWT.Modify );
            IObservableValue    therapeauticDrugScreenRqstRequestDateAndNumbernumberObserveValue                                                                 = BeansObservables.observeValue( therapeauticDrugScreenRqst,
                                                                                                                                                                                                  "requestDateAndNumber.number" );
            UpdateValueStrategy strategy_2                                                                                                                       = new UpdateValueStrategy();
            strategy_2.setConverter( new StringToBigIntegerConverter() );

            UpdateValueStrategy strategy_3 = new UpdateValueStrategy();
            strategy_3.setConverter( new BigIntegerToStringConverter() );
            bindingContext.bindValue( therapeauticDrugScreenRqstViewFormgetRequestDateAndNumberViewFormgetRequestDateAndNumberFormgetNumberTxtObserveTextObserveWidget,
                                      therapeauticDrugScreenRqstRequestDateAndNumbernumberObserveValue, strategy_2, strategy_3 );

            //
            IObservableValue therapeauticDrugScreenRqstViewFormgetTherapeauticDrugScreenRqstFormgetAntiepilepticsCBtnObserveSelectionObserveWidget = SWTObservables.observeSelection( therapeauticDrugScreenRqstViewForm
                                                                                                                                                                                              .getTherapeauticDrugScreenRqstForm()
                                                                                                                                                                                              .getAntiepilepticsCBtn() );
            IObservableValue therapeauticDrugScreenRqstAntiepilepticsObserveValue                                                                  = BeansObservables.observeValue( therapeauticDrugScreenRqst,
                                                                                                                                                                                    "antiepileptics" );
            bindingContext.bindValue( therapeauticDrugScreenRqstViewFormgetTherapeauticDrugScreenRqstFormgetAntiepilepticsCBtnObserveSelectionObserveWidget,
                                      therapeauticDrugScreenRqstAntiepilepticsObserveValue, null, null );

            //
            IObservableValue therapeauticDrugScreenRqstViewFormgetTherapeauticDrugScreenRqstFormgetDilantinCBtnObserveSelectionObserveWidget = SWTObservables.observeSelection( therapeauticDrugScreenRqstViewForm
                                                                                                                                                                                        .getTherapeauticDrugScreenRqstForm()
                                                                                                                                                                                        .getDilantinCBtn() );
            IObservableValue therapeauticDrugScreenRqstDilantinObserveValue                                                                  = BeansObservables.observeValue( therapeauticDrugScreenRqst,
                                                                                                                                                                              "dilantin" );
            bindingContext.bindValue( therapeauticDrugScreenRqstViewFormgetTherapeauticDrugScreenRqstFormgetDilantinCBtnObserveSelectionObserveWidget, therapeauticDrugScreenRqstDilantinObserveValue,
                                      null, null );

            //
            IObservableValue therapeauticDrugScreenRqstViewFormgetTherapeauticDrugScreenRqstFormgetPhenobarbCBtnObserveSelectionObserveWidget = SWTObservables.observeSelection( therapeauticDrugScreenRqstViewForm
                                                                                                                                                                                         .getTherapeauticDrugScreenRqstForm()
                                                                                                                                                                                         .getPhenobarbCBtn() );
            IObservableValue therapeauticDrugScreenRqstPhenobarbObserveValue                                                                  = BeansObservables.observeValue( therapeauticDrugScreenRqst,
                                                                                                                                                                               "phenobarb" );
            bindingContext.bindValue( therapeauticDrugScreenRqstViewFormgetTherapeauticDrugScreenRqstFormgetPhenobarbCBtnObserveSelectionObserveWidget, therapeauticDrugScreenRqstPhenobarbObserveValue,
                                      null, null );

            //
            IObservableValue therapeauticDrugScreenRqstViewFormgetTherapeauticDrugScreenRqstFormgetTegretolCBtnObserveSelectionObserveWidget = SWTObservables.observeSelection( therapeauticDrugScreenRqstViewForm
                                                                                                                                                                                        .getTherapeauticDrugScreenRqstForm()
                                                                                                                                                                                        .getTegretolCBtn() );
            IObservableValue therapeauticDrugScreenRqstTegretolObserveValue                                                                  = BeansObservables.observeValue( therapeauticDrugScreenRqst,
                                                                                                                                                                              "tegretol" );
            bindingContext.bindValue( therapeauticDrugScreenRqstViewFormgetTherapeauticDrugScreenRqstFormgetTegretolCBtnObserveSelectionObserveWidget, therapeauticDrugScreenRqstTegretolObserveValue,
                                      null, null );

            //
            IObservableValue therapeauticDrugScreenRqstViewFormgetTherapeauticDrugScreenRqstFormgetAntipsychoticsCBtnObserveSelectionObserveWidget = SWTObservables.observeSelection( therapeauticDrugScreenRqstViewForm
                                                                                                                                                                                              .getTherapeauticDrugScreenRqstForm()
                                                                                                                                                                                              .getAntipsychoticsCBtn() );
            IObservableValue therapeauticDrugScreenRqstAntipsychoticsObserveValue                                                                  = BeansObservables.observeValue( therapeauticDrugScreenRqst,
                                                                                                                                                                                    "antipsychotics" );
            bindingContext.bindValue( therapeauticDrugScreenRqstViewFormgetTherapeauticDrugScreenRqstFormgetAntipsychoticsCBtnObserveSelectionObserveWidget,
                                      therapeauticDrugScreenRqstAntipsychoticsObserveValue, null, null );

            //
            IObservableValue therapeauticDrugScreenRqstViewFormgetTherapeauticDrugScreenRqstFormgetLithiumCBtnObserveSelectionObserveWidget = SWTObservables.observeSelection( therapeauticDrugScreenRqstViewForm
                                                                                                                                                                                       .getTherapeauticDrugScreenRqstForm()
                                                                                                                                                                                       .getLithiumCBtn() );
            IObservableValue therapeauticDrugScreenRqstLithiumObserveValue                                                                  = BeansObservables.observeValue( therapeauticDrugScreenRqst,
                                                                                                                                                                             "lithium" );
            bindingContext.bindValue( therapeauticDrugScreenRqstViewFormgetTherapeauticDrugScreenRqstFormgetLithiumCBtnObserveSelectionObserveWidget, therapeauticDrugScreenRqstLithiumObserveValue,
                                      null, null );

            //
            IObservableValue therapeauticDrugScreenRqstViewFormgetTherapeauticDrugScreenRqstFormgetCardiotoxinsCBtnObserveSelectionObserveWidget = SWTObservables.observeSelection( therapeauticDrugScreenRqstViewForm
                                                                                                                                                                                            .getTherapeauticDrugScreenRqstForm()
                                                                                                                                                                                            .getCardiotoxinsCBtn() );
            IObservableValue therapeauticDrugScreenRqstCardiotoxinsObserveValue                                                                  = BeansObservables.observeValue( therapeauticDrugScreenRqst,
                                                                                                                                                                                  "cardiotoxins" );
            bindingContext.bindValue( therapeauticDrugScreenRqstViewFormgetTherapeauticDrugScreenRqstFormgetCardiotoxinsCBtnObserveSelectionObserveWidget,
                                      therapeauticDrugScreenRqstCardiotoxinsObserveValue, null, null );

            //
            IObservableValue therapeauticDrugScreenRqstViewFormgetTherapeauticDrugScreenRqstFormgetDigoxinCBtnObserveSelectionObserveWidget = SWTObservables.observeSelection( therapeauticDrugScreenRqstViewForm
                                                                                                                                                                                       .getTherapeauticDrugScreenRqstForm()
                                                                                                                                                                                       .getDigoxinCBtn() );
            IObservableValue therapeauticDrugScreenRqstDigoxinObserveValue                                                                  = BeansObservables.observeValue( therapeauticDrugScreenRqst,
                                                                                                                                                                             "digoxin" );
            bindingContext.bindValue( therapeauticDrugScreenRqstViewFormgetTherapeauticDrugScreenRqstFormgetDigoxinCBtnObserveSelectionObserveWidget, therapeauticDrugScreenRqstDigoxinObserveValue,
                                      null, null );

            //
            IObservableValue therapeauticDrugScreenRqstViewFormgetTherapeauticDrugScreenRqstFormgetHepatotoxinsCBtnObserveSelectionObserveWidget = SWTObservables.observeSelection( therapeauticDrugScreenRqstViewForm
                                                                                                                                                                                            .getTherapeauticDrugScreenRqstForm()
                                                                                                                                                                                            .getHepatotoxinsCBtn() );
            IObservableValue therapeauticDrugScreenRqstHepatotoxinsObserveValue                                                                  = BeansObservables.observeValue( therapeauticDrugScreenRqst,
                                                                                                                                                                                  "hepatotoxins" );
            bindingContext.bindValue( therapeauticDrugScreenRqstViewFormgetTherapeauticDrugScreenRqstFormgetHepatotoxinsCBtnObserveSelectionObserveWidget,
                                      therapeauticDrugScreenRqstHepatotoxinsObserveValue, null, null );

            //
            IObservableValue therapeauticDrugScreenRqstViewFormgetTherapeauticDrugScreenRqstFormgetAspirinCBtnObserveSelectionObserveWidget = SWTObservables.observeSelection( therapeauticDrugScreenRqstViewForm
                                                                                                                                                                                       .getTherapeauticDrugScreenRqstForm()
                                                                                                                                                                                       .getAspirinCBtn() );
            IObservableValue therapeauticDrugScreenRqstAspirinObserveValue                                                                  = BeansObservables.observeValue( therapeauticDrugScreenRqst,
                                                                                                                                                                             "aspirin" );
            bindingContext.bindValue( therapeauticDrugScreenRqstViewFormgetTherapeauticDrugScreenRqstFormgetAspirinCBtnObserveSelectionObserveWidget, therapeauticDrugScreenRqstAspirinObserveValue,
                                      null, null );

            //
            IObservableValue therapeauticDrugScreenRqstViewFormgetTherapeauticDrugScreenRqstFormgetOtherCBtnObserveSelectionObserveWidget = SWTObservables.observeSelection( therapeauticDrugScreenRqstViewForm
                                                                                                                                                                                     .getTherapeauticDrugScreenRqstForm()
                                                                                                                                                                                     .getOtherCBtn() );
            IObservableValue therapeauticDrugScreenRqstOtherObserveValue                                                                  = BeansObservables.observeValue( therapeauticDrugScreenRqst,
                                                                                                                                                                           "other" );
            bindingContext.bindValue( therapeauticDrugScreenRqstViewFormgetTherapeauticDrugScreenRqstFormgetOtherCBtnObserveSelectionObserveWidget, therapeauticDrugScreenRqstOtherObserveValue, null,
                                      null );

            //
            IObservableValue therapeauticDrugScreenRqstViewFormgetTherapeauticDrugScreenRqstFormgetOtherRqstFormgetRequestTxtObserveTextObserveWidget = SWTObservables.observeText( therapeauticDrugScreenRqstViewForm
                                                                                                                                                                                            .getTherapeauticDrugScreenRqstForm()
                                                                                                                                                                                            .getOtherRqstForm()
                                                                                                                                                                                            .getRequestTxt(),
                                                                                                                                                                                    SWT.Modify );
            IObservableValue therapeauticDrugScreenRqstOtherRqstrequestObserveValue                                                                   = BeansObservables.observeValue( therapeauticDrugScreenRqst,
                                                                                                                                                                                       "otherRqst.request" );
            bindingContext.bindValue( therapeauticDrugScreenRqstViewFormgetTherapeauticDrugScreenRqstFormgetOtherRqstFormgetRequestTxtObserveTextObserveWidget,
                                      therapeauticDrugScreenRqstOtherRqstrequestObserveValue, null, null );

            //
            IObservableValue    therapeauticDrugScreenRqstViewFormgetRequestDateAndNumberViewFormgetRequestDateAndNumberFormgetMrnTxtObserveTextObserveWidget_1 = SWTObservables.observeText( therapeauticDrugScreenRqstViewForm
                                                                                                                                                                                                      .getRequestDateAndNumberViewForm()
                                                                                                                                                                                                      .getRequestDateAndNumberForm()
                                                                                                                                                                                                      .getMrnTxt(),
                                                                                                                                                                                              SWT.Modify );
            IObservableValue    therapeauticDrugScreenRqstOtherRqstrequestDateAndNumbermrnObserveValue                                                          = BeansObservables.observeValue( therapeauticDrugScreenRqst,
                                                                                                                                                                                                 "otherRqst.requestDateAndNumber.mrn" );
            UpdateValueStrategy strategy_4                                                                                                                      = new UpdateValueStrategy();
            strategy_4.setConverter( new StringToBigIntegerConverter() );

            UpdateValueStrategy strategy_5 = new UpdateValueStrategy();
            strategy_5.setConverter( new BigIntegerToStringConverter() );
            bindingContext.bindValue( therapeauticDrugScreenRqstViewFormgetRequestDateAndNumberViewFormgetRequestDateAndNumberFormgetMrnTxtObserveTextObserveWidget_1,
                                      therapeauticDrugScreenRqstOtherRqstrequestDateAndNumbermrnObserveValue, strategy_4, strategy_5 );

            //
            IObservableValue    therapeauticDrugScreenRqstViewFormgetRequestDateAndNumberViewFormgetRequestDateAndNumberFormgetNumberTxtObserveTextObserveWidget_1 = SWTObservables.observeText( therapeauticDrugScreenRqstViewForm
                                                                                                                                                                                                         .getRequestDateAndNumberViewForm()
                                                                                                                                                                                                         .getRequestDateAndNumberForm()
                                                                                                                                                                                                         .getNumberTxt(),
                                                                                                                                                                                                 SWT.Modify );
            IObservableValue    therapeauticDrugScreenRqstOtherRqstrequestDateAndNumbernumberObserveValue                                                          = BeansObservables.observeValue( therapeauticDrugScreenRqst,
                                                                                                                                                                                                    "otherRqst.requestDateAndNumber.number" );
            UpdateValueStrategy strategy_6                                                                                                                         = new UpdateValueStrategy();
            strategy_6.setConverter( new StringToBigIntegerConverter() );

            UpdateValueStrategy strategy_7 = new UpdateValueStrategy();
            strategy_7.setConverter( new BigIntegerToStringConverter() );
            bindingContext.bindValue( therapeauticDrugScreenRqstViewFormgetRequestDateAndNumberViewFormgetRequestDateAndNumberFormgetNumberTxtObserveTextObserveWidget_1,
                                      therapeauticDrugScreenRqstOtherRqstrequestDateAndNumbernumberObserveValue, strategy_6, strategy_7 );

        }
        catch( Throwable e )
        {
            System.err.println( "com.epimss.lab.ui.toxicology.TherapeauticDrugScreenRqstWizardPage.initDataBindings(), " + e );

        }   // end try-catch


        //
        return( bindingContext );

    }   // end method initDataBindings


    /**
     * Retrieves the <code>pageValid</code> property from this bean.
     *
     * @created  June 30, 2011 4:03:36 PM by St Clair Clarke
     *
     * @return   <code>boolean</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    protected boolean isPageValid()
    {
        return(
                therapeauticDrugScreenRqstViewForm.getTherapeauticDrugScreenRqstForm()
                                                  .isFormValid() && therapeauticDrugScreenRqstViewForm.getRequestDateAndNumberViewForm()
                                                                                                      .getRequestDateAndNumberForm()
                                                                                                      .isFormValid()
               );

    }   // end method isPageValid


    /**
     * Retrieves the <code>m_bindingContext</code> property from this bean.
     *
     * @created  June 21, 2011 5:37:12 PM by St Clair Clarke
     *
     * @return   <code>DataBindingContext</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    protected DataBindingContext getM_bindingContext()
    {
        return( m_bindingContext );

    }   // end method getM_bindingContext


    /**
     * Sets the value of the <code>m_bindingContext</code> property of this bean.
     *
     * @created  June 21, 2011 5:37:12 PM by St Clair Clarke
     *
     * @param    m_bindingContext  <code>DataBindingContext</code> DTODO!
     *
     * @since    1.0
     */
    protected void setM_bindingContext( DataBindingContext m_bindingContext )
    {
        this.m_bindingContext = m_bindingContext;

    }   // end method setM_bindingContext


    /**
     * Retrieves the <code>therapeauticDrugScreenRqst</code> property from this bean.
     *
     * @created  June 21, 2011 5:37:12 PM by St Clair Clarke
     *
     * @return   <code>TherapeauticDrugScreenRqst</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    protected TherapeauticDrugScreenRqst getTherapeauticDrugScreenRqst()
    {
        return( therapeauticDrugScreenRqst );

    }   // end method getTherapeauticDrugScreenRqst


    /**
     * Sets the value of the <code>therapeauticDrugScreenRqst</code> property of this bean.
     *
     * @created  June 21, 2011 5:37:12 PM by St Clair Clarke
     *
     * @param    therapeauticDrugScreenRqst  <code>TherapeauticDrugScreenRqst</code> DTODO!
     *
     * @since    1.0
     */
    protected void setTherapeauticDrugScreenRqst( TherapeauticDrugScreenRqst therapeauticDrugScreenRqst )
    {
        this.therapeauticDrugScreenRqst = therapeauticDrugScreenRqst;

    }   // end method setTherapeauticDrugScreenRqst


    /**
     * Retrieves the <code>therapeauticDrugScreenRqstViewForm</code> property from this bean.
     *
     * @created  June 21, 2011 5:37:12 PM by St Clair Clarke
     *
     * @return   <code>TherapeauticDrugScreenRqstViewForm</code> type if suscessfully executes.
     *
     * @since    1.0
     */
    protected TherapeauticDrugScreenRqstViewForm getTherapeauticDrugScreenRqstViewForm()
    {
        return( therapeauticDrugScreenRqstViewForm );

    }   // end method getTherapeauticDrugScreenRqstViewForm

}   // end class TherapeauticDrugScreenRqstWizardPage
